﻿// Add any initialization logic to this function.
Office.initialize = function (reason) {

    // Checks for the DOM to load.
    $(document).ready(function () {
        $("#getDatabtn").click(function () { getData("selectedData"); });

        // Checks if setSelectedDataAsync is supported and adds appropriate click handler
        if (Office.context.document.setSelectedDataAsync) {
            $("#setDatabtn").click(function () { setData("Sample data"); });
        }
        else {
            $("#setDatabtn").remove();
        }
    });
}

// Writes data to current selection.
function setData(tableType) {
    Office.context.document.setSelectedDataAsync(createTablefromTemplate(tableType));
}

// Reads data from current selection.
function getData(elementIdToUpdate) {
    Office.context.document.getSelectedDataAsync(Office.CoercionType.Text,
    function (result) {
        if (result.status == "succeeded") {
            document.getElementById(elementIdToUpdate).value = result.value;
        }
    });
}





function createTablefromTemplate(tableType) {
    var tableData = new Office.TableData();
    switch (tableType) {
        case "task":
            tableData.headers = [['Task Title', 'Start Date', 'Due Date', 'Status', 'Category', 'Assigned To']];
            tableData.rows = [['Sample Task #1', '=Today()', '=Today()+1', 'Not Started', 'Work', 'Me'], ['Sample Task #2', '=Today()', '=Today()', 'Not Started', 'Work', 'Me'], ['Sample Task #3', '=Today()', '=Today()', 'Not Started', 'Work', 'Me']];
            return tableData;
            break;

        case "contact":
            tableData.headers = [['First Name', 'Last Name', 'Title', 'Phone Number', 'Email', 'Street', 'City', 'State', 'Zip']];
            tableData.rows = [['John', 'Doe', 'Generic Person', '212-555-1212', 'john@doe.com', '1234 Main', 'Oakland', 'CA', '94601']];
            return tableData;
            break;

        case "expense":
            tableData.headers = [['Expense Date', 'Category', 'Client/Project', 'Amount']];
            tableData.rows = [['=Today()', 'Meals', 'Custom App for Office', '$55.00']];
            return tableData;
            break;

        case "issue":
            tableData.headers = [['Issue', 'Status', 'Priority', 'Area', 'Due Date', 'Date Resoled', 'Notes']];
            tableData.rows = [['Severely limited Office.js API', 'In-Progress', 'Normal', 'Development', '=today()+7', '', 'I wish the API was more extensive.']];
            return tableData;
            break;


    }
}
